import processing.video.*;
import krister.Ess.*;

Capture cam;

AudioStream myStream;
AudioInput myInput;

//instantiates SpinLines
SpinLines lines;

// instantiates reverse
//Reverse myReverse;

boolean inputReady=false;
float[] streamBuffer;

float cc = 0;
PImage tMask;
boolean b = false;

int currentRate = 60;

void setup(){
  size(800,800);
  cam = new Capture(this, 800,800);
  tMask = loadImage("mask.png");
  background(0);
  smooth();
  frameRate(currentRate);
  
  lines = new SpinLines(width/2, height/2, 0.01);
  
  
  
  // start up Ess
  Ess.start(this);

  // create a new AudioInput
  myInput=new AudioInput(); 
  
  // reverse first second
  //myReverse=new Reverse();
  //myReverse.filter(myStream,myStream);
  

  // create a new AudioStream
  myStream=new AudioStream(myInput.size);
  streamBuffer=new float[myInput.size];



  // start
  myStream.start();
  myInput.start();
  
  
    
  
}

void draw(){
  
 
  // rotates image clockwise if 'r' pressed 
  if(keyPressed) {
    if (key == 'r' || key == 'R') {
      cc+=0.1;
    } 
  } else {
     cc+= 0;
  }
  
  // spins anticlockwise
  if(keyPressed) {
    if (key == 'a' || key == 'A') {
      cc-=0.1;
      
      
    } 
  } else {
     cc-= 0;
  }
  
  
  // spins fast
  if(keyPressed) {
    if (key == 'f' || key == 'F') {
      cc+=1;
    } 
  } 
  
  // spins slow 
  if(keyPressed) {
    if (key == 's' || key == 'S') {
      cc+=0.01;
    } 
  } 
  
   // draws spinning lines to the screen
  if(keyPressed) {
    if (key == 'l' || key == 'L') {
       lines.update();
       lines.display();
    } 
  } 
  

  // clears the screen
  if(keyPressed) {
    if(key == 'c' || key == 'C'){
      background(0);
    }  
  } 
  
        // slows the framerate
  if(keyPressed) {
    if(key == 'v' || key == 'V'){
      for (int i = 0; i < 60; i++)
      frameRate(currentRate - i);
    }  
  } 
  

  
    // reinstates normal frameRate
    if(keyPressed) {
    if(key == 'b' || key == 'B'){
      frameRate(currentRate);
    }  
  } 
  
  
  
    // draws more videoscopes to the screen 
    if(keyPressed) {
    if(key == 'm' || key == 'M'){
      pushMatrix();
      translate(width/2, height/2);
      rotate(radians(45));
      drawCam(0,800);
      popMatrix();
    }  
  } 
  
  
  
  
 //background(0);
  
 
  
  // draws the video capture to the screen
  pushMatrix();
  translate(width/2, height/2);
  drawCam(0,800);
  popMatrix();
  
 
  // overlay an average of the samples in the input buffer
  float inc=myInput.buffer.length/256.0f;
  for (int i=0;i<256;i++) {
    int y=(int)(100+myInput.buffer[(int)(i*inc)]*100);
  }
  
  
  
 
}





void drawCam (float pos, int siz) {
  float angle = radians(90);
  
  if (cam.available() == true) {
  cam.read();
 
  //tint (255,255);
  rotate(cc);
  cam.mask(tMask);
  tint(255, 100);
  pushMatrix();
  imageMode(CENTER);
  rotate(angle);
  image(cam, pos, -pos, siz, siz);
  rotate(angle);
  image(cam, -pos, -pos, siz, siz);
  rotate(angle);
  image(cam, -pos, pos, siz, siz);
  rotate(angle);
  image(cam, pos, pos, siz, siz);
  popMatrix();
  
  // creates concentric groups of triangles
  blend(0, 0, 800, 800,200 ,200, 400, 400, BLEND);  
  
  }
}

void audioStreamWrite(AudioStream theStream) {
  // block until we have some input
  while (!inputReady); 
  
  System.arraycopy(streamBuffer,0,myStream.buffer,0,streamBuffer.length);
   
  inputReady=false;
}

void audioInputData(AudioInput theInput) {
  System.arraycopy(myInput.buffer,0,streamBuffer,0,myInput.size);
  
  inputReady=true;
}

// we are done, clean up Ess

public void stop() {
  Ess.stop();
  super.stop();
}


class Spin 
{
  float x, y, speed;
  float angle = 0.0;
  Spin(float xpos, float ypos, float s) {
    x = xpos;
    y = ypos;
    speed = s;
  }
  void update() {
    angle += speed;   //speed defines speed of rotation
  }
}

class SpinLines extends Spin{
  SpinLines (float x, float y, float s){
    super(x, y, s);
  }
  
  void display(){
    strokeWeight(1);
    stroke(255);
    pushMatrix();
    translate(x,y);
    angle +=speed;
    rotate(angle);
    line(0,0, 400, 0);
    line(0,0, 0, 400);
    line(0,0, -400, 0);
    line(0,0, 0, -400);
    
     
    popMatrix();
  }
}




void mousePressed() {
  
     save("videoscope.jpg");
    
 }



